package HemissonComm;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;

import javax.comm.CommPortIdentifier;
import javax.comm.NoSuchPortException;
import javax.comm.PortInUseException;
import javax.comm.SerialPort;
import javax.comm.UnsupportedCommOperationException;

import com.sun.comm.Win32Driver;

public class SerialComm {
	private BufferedReader bufRead; //flux de lecture du port

	private OutputStream outStream; //flux d'criture du port

	private CommPortIdentifier portId; //identifiant du port

	private SerialPort sPort; //le port srie

	/**
	 * Constructor
	 */
	public SerialComm(String port) {
		//initialisation du driver
		Win32Driver w32Driver = new Win32Driver();
		w32Driver.initialize();
		//rcupration de l'identifiant du port
		try {
			portId = CommPortIdentifier.getPortIdentifier(port);
		} catch (NoSuchPortException e) {
			System.err.println("Problem get Port ID");
		}
		//ouverture du port
		try {
			sPort = (SerialPort) portId.open("HemissonCom", 30000);
		} catch (PortInUseException e) {
			System.err.println("Problem HemissonCom Open");
		}
		//rgle les paramtres de la connexion
		try {
			sPort.setSerialPortParams(115200, SerialPort.DATABITS_8,
					SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
		} catch (UnsupportedCommOperationException e) {
			System.err.println("Problem HemissonCom Set Parameter Port");
		}
		//rcupration du flux de lecture et criture du port
		try {
			outStream = sPort.getOutputStream();
			bufRead = new BufferedReader(new InputStreamReader(sPort
					.getInputStream()));
		} catch (IOException e) {
		}
	}

	/**
	 * Mthode de communication.
	 */
	public BufferedReader communique(String filename) {
		char[] command;
		try {
			command = filename.toCharArray();
			
			outStream.write((int) '\r');
			Thread.sleep(100);

			Thread.sleep(100);
			//outStream.write((int)envoie);
			for (int i = 0; i < command.length; i++) {
				outStream.write((int) command[i]);
				Thread.sleep(100);
			}
			outStream.write((int) '\r');
			Thread.sleep(100);

		} catch (Exception e) {
		}
		return bufRead;
	}

	/**
	 * Mthode de fermeture des flux et port.
	 */
	public void close() {
		try {
			bufRead.close();
			outStream.close();
		} catch (IOException e) {
		}
		sPort.close();
	}

}
