package HemissonIHM;



//Cration de boutons radio  laide de ButtonGroup et JRadioButton.
import java.awt.*;
import java.awt.event.*;
import java.io.BufferedReader;

import javax.swing.*;

import HemissonComm.SerialComm;

public class MainFrame extends JFrame {
	private JTextField MoteurGauche,MoteurDroite,on,pgm,ag,ad,result;
	private JRadioButton B, D, E, H,I,L,N,O;
	private ButtonGroup groupeBRadio;
	private FlowLayout flowlayout;
	private SerialComm serialComm;
	private JLabel res;
	private int buzzer = 0;

	
	public MainFrame()
	{
		super( "Hemisson Demo" );
		serialComm = new SerialComm("COM40");
		Container c = getContentPane();
		flowlayout = new FlowLayout();
		flowlayout.setAlignment(10);
		c.setLayout( flowlayout );
		
		
		
		// Crer les boutons radio.
		B = new JRadioButton( "Version Hemisson OS");
		c.add( B );
		D = new JRadioButton( "Vitesse Moteur");
		c.add( D );
		
		MoteurGauche = new JTextField( "0", 2 );
		c.add( MoteurGauche ); 
		
		MoteurDroite = new JTextField( "0", 2 );
		c.add( MoteurDroite ); 
		
		E = new JRadioButton( "Lecture Vitesse Moteur");
		c.add( E );
		
		H = new JRadioButton( "Buzzer actif/inactif");
		c.add( H );
		
		I = new JRadioButton( "Lecture interupteur");
		c.add( I );
		
		L = new JRadioButton( "Allumer/teindre LED");
		c.add( L );
		
		on = new JTextField( "0", 1 );
		c.add( on );
		pgm = new JTextField( "0", 1 );
		c.add( pgm );
		ag = new JTextField( "0", 1 );
		c.add( ag );
		ad = new JTextField( "0", 1 );
		c.add( ad );
		
		
		N = new JRadioButton("Lecture valeur capteur proximit");
		c.add( N );
		
		O = new JRadioButton( "Lecture valeur Luminosit");
		c.add( O );
		
		res = new JLabel("Resultat de la commande:");
		c.add(res);
		result = new JTextField(20);
		c.add(result);
		// inscrire les vnements.
		GestionBoutonRadio gestionnaire = new GestionBoutonRadio();
		B.addItemListener( gestionnaire );
		D.addItemListener( gestionnaire );
		E.addItemListener( gestionnaire );
		H.addItemListener( gestionnaire );
		I.addItemListener( gestionnaire );
		L.addItemListener( gestionnaire );
		N.addItemListener( gestionnaire );
		O.addItemListener( gestionnaire );
		
		// crer la relation logique entre les JRadioButton.
		//groupeBRadio = new ButtonGroup();
		//groupeBRadio.add( B );
		//groupeBRadio.add( D );
		//groupeBRadio.add( E );
		//groupeBRadio.add( H );
		//groupeBRadio.add( I );
		//groupeBRadio.add( L );
		//groupeBRadio.add( N );
		//groupeBRadio.add( O );

	
		
		
		setSize( 270, 350 );
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
				serialComm.close();
			}
		});
		show();
	}
	
	
	private class GestionBoutonRadio implements ItemListener {
		public void itemStateChanged( ItemEvent e )
		{
			try{
				BufferedReader bufRead = null;
				String line;
				
				if (( e.getSource() == B ) && B.isSelected()){
					bufRead = serialComm.communique("B");
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("b")){
							result.setText(line);
							
						}
					}
					B.doClick();
					
				}
				
				else if (( e.getSource() == D ) && D.isSelected()){
					String command = "D,"+MoteurGauche.getText()+","+MoteurDroite.getText();
					bufRead = serialComm.communique(command);
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("d")){
							result.setText(line);
							break;
						}
					}
					D.doClick();
				
				}
				else if (( e.getSource() == E ) && E.isSelected()){
					bufRead = serialComm.communique("E");
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("e")){
							result.setText(line);
							break;
						}
					}
					E.doClick();
				}
				
				else if (( e.getSource() == H )&& H.isSelected()){
					if(buzzer==1)
						buzzer=0;
					else
						buzzer=1;
					
					bufRead = serialComm.communique("H,"+buzzer);
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("h")){
							result.setText(line);
							break;
						}
					}
					H.doClick();
				}
				else if (( e.getSource() == I ) && I.isSelected()){
					bufRead = serialComm.communique("I");
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("i")){
							result.setText(line);
							break;
						}
					}
					I.doClick();
				}
				else if (( e.getSource() == L ) && L.isSelected()){
					String command = "L,"+on.getText()+","+ pgm.getText()+","+ ag.getText()+","+ ad.getText();
					System.out.println(command);
					bufRead = serialComm.communique(command);
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("l")){
							result.setText(line);
							break;
						}
					}
					L.doClick();
				}
				else if (( e.getSource() == N ) && N.isSelected()){
					bufRead = serialComm.communique("N");
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("n")){
							result.setText(line);
							break;
						}
					}
					N.doClick();
				}
				else if (( e.getSource() == O ) && O.isSelected()){
					bufRead = serialComm.communique("O");
					while (bufRead.ready()) {
						line = bufRead.readLine();
						if (line.startsWith("o")){
							result.setText(line);
							break;
						}
					}
					O.doClick();
				}

			} catch (Exception e2) {
				System.out.println("Problem read Buf");
			}
			
		}
	}
	
}
	
